<template>
    <div class="col-md-6 col-sm-6">
        <form autocomplete="off">
            <div class="col-sm-12 element-container text-element">
                <div class="form-row">
                    <div class="form-group">
                        <label class="control-label" for="sale-phone">{{ $trans('app.Номер телефона') }}</label>
                        <div class="d-flex mb-3">
                            <input placeholder="380961234567" v-model="formData.number" autofocus name="number"
                                   id="sale-phone" autocomplete="false" type="text" class="form-control"
                                   :class='{"is-invalid": formDataErrors["number"]}'/>
                            <div class="input-group-append">
                                <qrscanner @result="qrScannerResult"></qrscanner>
                            </div>
                        </div>
                        <small id="emailHelp" class="form-text text-muted">Номер телефона вводите в формате
                            380961234567</small>
                        <div v-if="formDataErrors['number']" class="invalid-feedback">{{ formDataErrors['number'] }}
                        </div>
                    </div>
                </div>
                <div class="form-row ">
                    <div class="form-group">
                        <button @click="findByNumber()" type="button" class="btn btn-info">{{
                            $trans('app.Искать') }}
                        </button>
                    </div>
                </div>
            </div>
            <div v-if="showSaleSubscription">
                <div class="text-center">
                    <h3>{{ $trans('app.Нет активных абонементов') }}</h3>
                    <a :href="$route('sale.subscription') + '?' + (clientData.phone ? ('phone=' + clientData.phone.toString()) : '') + '&back=' + backUrl"
                       class="btn btn-warning">{{ $trans('app.Продать абонемент') }}</a>
                </div>
                <br>
            </div>

            <div v-if="showCreateBtn">
                <div class="text-center">
                    <a :href="$route('clients.create') + '?phone=' + formData.number.toString() + '&back=' + backUrl"
                       class="btn btn-warning">{{ $trans('app.Создать клиента') }}</a>
                </div>
                <br>
            </div>

            <div v-if="clientFounded" class="client-data ">
                <div class="col-sm-12 element-container">
                    <label class="control-label">{{ clientData.username }}</label>
                </div>
                <hr>
            </div>

            <div v-if="subscriptionFounded" class="subscription-data ">
                <div class="col-sm-12 element-container">
                    <div class="form-group">
                        <div class="row">
                            <div v-for="subscription in subscriptions" class="col-sm-12 col-lg-4"
                                 style="margin-bottom: 5px"
                                 :class="{'subscription-selected': formData.client_subscription_id == subscription.id}">
                                <div class="card">
                                    <div class="card-body">
                                        <h5 class="card-title"> {{ subscription.title }}</h5>
                                        <div class="card-text">
                                            <ul>
                                                <li>{{ $trans('app.Период') }}: <b>{{ subscription.validity
                                                    }}</b>
                                                </li>
                                                <li>{{ $trans('app.Занятий') }}: <b>{{
                                                    subscription.quantity_of_occupation }}</b></li>
                                            </ul>
                                        </div>
                                        <div v-if="formData.client_subscription_id == subscription.id"
                                             class="btn btn-success">{{ $trans('app.Выбрано') }}
                                        </div>
                                        <div v-else class="btn btn-light"
                                             @click="formData.client_subscription_id = subscription.id">{{
                                            $trans('app.Выбрать') }}
                                        </div>
                                    </div>
                                </div>
                            </div>
                        </div>
                    </div>

                    <div :class='{"is-invalid": formDataErrors["client_id"]}'></div>
                    <div v-if="formDataErrors['client_id']" class="invalid-feedback">{{ formDataErrors['client_id']
                        }}
                    </div>
                    <div :class='{"is-invalid": formDataErrors["client_subscription_id"] }'></div>
                    <div v-if="formDataErrors['client_subscription_id']" class="invalid-feedback">{{
                        formDataErrors['client_subscription_id'] }}
                    </div>

                    <div class="col-sm-12 element-container text-element">
                        <div class="form-group">
                            <div class="row">
                                <div class="col-sm-2">
                                    <label class="control-label" for="number">{{ $trans('app.Ключ') }}</label>
                                </div>
                                <div class="col-sm-6 row">
                                    <input v-model="formData.key_number" name="key_number" id="key_number"
                                           autocomplete="false" type="text" class="form-control"
                                           :class='{"is-invalid": formDataErrors["key_number"]}'/>
                                    <div v-if="formDataErrors['key_number']" class="invalid-feedback">{{
                                        formDataErrors['key_number'] }}
                                    </div>
                                </div>
                            </div>
                        </div>
                    </div>

                    <div class="col-sm-12 element-container text-element">
                        <div class="form-group">
                            <div class="row">
                                <div class="col-sm-2">
                                    <label class="control-label" for="number">Сотрудник</label>
                                </div>
                                <div class="col-sm-12 col-lg-4 row">
                                    <select class="form-control" v-model="formData.staff_id">
                                        <option v-for="(value, key) in JSON.parse(this.staffs)" :value="value.id">{{ value.name
                                            }}
                                        </option>
                                    </select>
                                </div>
                            </div>
                        </div>
                    </div>
                </div>

                <hr>
                <div class="col-sm-12 element-container">
                    <div class="form-group row submit-btn-wrap">
                        <div class="offset-2 col-sm-10">
                            <button @click="checkVisit" type="button" class="btn btn-success btn-lg">{{
                                $trans('app.Фиксировать посещение') }}
                            </button>
                        </div>
                    </div>
                </div>
            </div>
        </form>
    </div>
</template>

<script>
    import QRScanner from "./QRScanner";

    export default {
        props: ["number", "staffs", "staff_id"],
        components: {
            'qrscanner': QRScanner
        },
        data: () => ({
            "formData": {
                "client_id": "",
                "client_subscription_id": "",
                "number": "",
                "key_number": "",
                "staff_id": null,
            },
            "formDataErrors": {},
            "clientData": {},
            "subscriptions": [],
            "clientFounded": false,
            "subscriptionFounded": false,
            "showCreateBtn": false,
            "showSaleSubscription": false,
            "disabledCheckVisit": false,
            "backUrl": "",

        }),
        methods: {
            "findByNumber": function () {
                this.resetErrors();

                axios.get(routes('clients.find-by-number') + '?number=' + this.formData.number).then(response => {
                    const {data} = response.data;

                    this.clientData = data.client;

                    this.formData.client_id = this.clientData.id;
                    this.subscriptions = data.subscriptions;

                    if (this.subscriptions.length) {
                        this.formData.client_subscription_id = this.subscriptions[0].id;
                    }

                    this.clientFounded = this.subscriptionFounded = true;

                }).catch(error => {
                    this.clientFounded = this.subscriptionFounded = false;
                    const {data, status} = error.response;

                    if (status === 422) {
                        this.showFormErrors(data.errors);
                    } else if (status === 404) {
                        this.clientData = data.clientData;

                        if (data.code == 'client_not_found') {
                            this.showCreateBtn = true;
                        } else if (data.code == 'subscription_not_found') {
                            this.showSaleSubscription = true;
                        }
                    }
                });
            },
            "checkVisit": function () {
                if (this.disabledCheckVisit) {
                    return;
                }
                this.disabledCheckVisit = true;

                let formData = toFormData(this.formData);

                axios.post(routes('client-visit.create'), formData).then(response => {
                    location.href = response.data.back;
                }).catch(error => {
                    const {data, status} = error.response;

                    if (status === 422) {
                        this.showFormErrors(data.errors);
                    }
                }).finally(() => {
                    this.disabledCheckVisit = false;
                });

            },
            "showFormErrors": function (errors) {
                for (let field in errors) {
                    this.formDataErrors[field] = errors[field].join('; ');
                }
            },
            resetErrors: function () {
                this.formDataErrors = {
                    "number": false,
                    "client_subscription_id": false,
                    "client_id": false,
                }

                this.showCreateBtn = false;
                this.showSaleSubscription = false;
            },
            qrScannerResult(result) {
                if (result) {
                    this.formData.number = result;
                    this.findByNumber();
                }
            }
        },
        created() {
            if (this.staff_id) {
                this.formData.staff_id = this.staff_id;
            }

            this.resetErrors();

            if (this.number) {
                this.formData.number = this.number;
                this.findByNumber();
            }

            this.subscriptionValues = _.map(this.subscriptions, (o, key) => {
                return {"label": o.title + ' ' + o.price, "value": key}
            });

            this.backUrl = location.href;
        }, watch: {
            "formData.number": function () {
                this.clientFounded = false;
                this.subscriptionFounded = false;
                this.disabledCheckVisit = false;
                this.showSaleSubscription = false;
                this.showCreateBtn = false;
            },
        }
    }
</script>
